#include <stdlib.h>
#include <math.h>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLPOINTPARAMETERFVPROC glPointParameterfv;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 }; /* ʒu@@@ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ڌx */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* x */

/*
** p[eBN
*/
#include "particle.h"
#include <deque>
#define MAX_PARTICLES 800
static std::deque<particle> particles;
static GLfloat distance[] = { 0.0, 0.0, 1.0 };

/*
** nʂ̍
*/
#define HEIGHT -1.0

/*
** 
*/
static void init(void)
{
#if defined(WIN32)
  glPointParameterfv =
    (PFNGLPOINTPARAMETERFVPROC)wglGetProcAddress("glPointParameterfv");
#endif

  /* ݒ */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);

  /* Aet𖳌ɂ */
  glDisable(GL_LIGHTING);

  /* nʂ̍ */
  particle::height(HEIGHT);

  /* ɑ΂_̑傫̐ */
  glPointParameterfv(GL_POINT_DISTANCE_ATTENUATION, distance);

  /* _ɃA`GAVOs */
  glEnable(GL_POINT_SMOOTH);

  /* A`GAVO̕iōɂ */
  glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);

  /* At@ufBOLɂ */
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_BLEND);
}

/*
** V[̕`
*/
static void scene(void)
{
  /* p[eBN𐶐 */
  if (particles.size() >= MAX_PARTICLES) {
    particles.pop_back();
  }
  particle p;
  particles.push_front(p);

  /* p[eBN` */
  glColor3d(1.0, 1.0, 1.0);
  glBegin(GL_POINTS);
  for (std::deque<particle>::iterator ip = particles.begin();
		  ip != particles.end(); ++ip) {
    ip->show();
    ip->update();
  }
  glEnd();
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

#include "trackball.h" /* gbN{[p֐̐錾 */

static void display(void)
{
  /* fr[ϊs̏ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* _̈ړî̕Ɉړj*/
  glTranslated(0.0, 0.0, -3.0);
  
  /* gbN{[ɂ] */
  glMultMatrixd(trackballRotation());
  
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* V[̕` */
  scene();
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 100.0);

  /* _̑傫XN[̕ɔႳ */
  glPointSize((float)w * 0.1f);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutIdleFunc(idle);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
